library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity compitov2 is
	port ( din: in std_logic_vector(15 downto 0);
	clk, rst, esegui: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic );
end compitov2;

architecture beh of compitov2 is
type stati is (idle,letop,decodifica, letd1,exeshl,exeor,execnt,exepar);
signal st: stati;
signal op: std_logic_vector(1 downto 0);
signal no_fine: std_logic;
signal d0,d1: std_logic_vector(15 downto 0);
signal enop,end0,end1,enshl,enor,encnt,enpar: std_logic;
signal conta: integer range 0 to 1;
begin	  
	
process(rst,clk)
begin
	if rst = '1' then st <= idle;
	elsif clk'event and clk='0' then 
	 case st is
		when idle => if esegui = '1' then st <= letop;
		             else st <= idle;
					 end if;
		when letop => st <= decodifica;
		when decodifica => -- decodifica
					case op is
					 when "00" | "01" => st <= letd1;
					 when "10" => st <= execnt;
					 when "11" => st <= exepar;
					 when others => st <= idle;
				   end case;
		when letd1 =>  if op(0) = '0' then st <= exeshl;
		               else st <= exeor;
					   end if;
		when exeshl => if no_fine = '1' then st <=  exeshl;
		               else st <= idle;
					   end if;
		when exepar => if no_fine = '1' then st <=  exepar;
		               else st <= idle;
					   end if; 			   
		when others => st <= idle;
	end case;
end if;
end process;


 enop <= '1' when st = letop  else '0';
 end0 <= '1' when st = decodifica  else '0';
 end1 <= '1'  when st = letd1 else '0';
 enshl <= '1' when st = exeshl else '0';
 enor <= '1' when st = exeor else '0';
 encnt <= '1' when st = execnt else '0';
 enpar <= '1' when st = exepar else '0';
	 
 no_fine <= '1' when (enshl='1' or enpar='1') and conta=0  else '0';

process(clk)  
variable num: integer range 0 to 16;
begin
	if clk'event and clk='0' then
		if enop ='1' then op<= din(1 downto 0);
			conta<=0;
	    end if;
		
		if end0 = '1' then d0 <= din;
		end if;
		if end1 = '1' then d1 <= din;
		end if;
		if enor = '1' then ris <= d0 or d1;
		end if;
		if encnt = '1' then
			num:=0;
			for i in 0 to 15 loop
				if d0(i) = '1' then num := num+1;
				end if;
			end loop;
			ris <= conv_std_logic_vector(num,16);
		end if;
		if enshl ='1' then
			if no_fine= '0' then
				ris <= shl(d0,d1);
	 		else conta <= 1;
		   end if;
		end if;
		
		if enpar = '1' then 
			if no_fine= '0' then
			  num:=0;
			  for i in 0 to 15 loop
				if d0(i) = '1' then num := num+1;
				end if;
			  end loop;
			  ris <= conv_std_logic_vector(num mod 2, 16);
			else conta <= 1;
			end if;	
		  end if;
		  
		fine <= enor or encnt or ((enshl or enpar) and not no_fine); 
     end if;
	end process;
end beh;
	


