library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity compitov4 is
	port ( din: in std_logic_vector(15 downto 0);
	clk, rst, esegui: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic );
end compitov4;

architecture beh of compitov4 is
type stati is (idle,letop,decodifica, letd1,exe1c,exe2c);
signal st: stati;
signal op: std_logic_vector(1 downto 0);
signal no_fine: std_logic;
signal d0,d1: std_logic_vector(15 downto 0);
signal enop,end0,end1,enexe1c,enexe2c: std_logic;
signal conta: std_logic;
begin	  
	
process(rst,clk)
begin
	if rst = '1' then st <= idle;
	elsif clk'event and clk='0' then 
	 case st is
		when idle => if esegui = '1' then st <= letop;
		             else st <= idle;
					 end if;
		when letop => st <= decodifica;
		when decodifica => -- decodifica
					case op is
					 when "00" | "01" => st <= letd1;
					 when "10" => st <= exe1c;
					 when "11" => st <= exe2c;
					 when others => st <= idle;
				   end case;
		when letd1 =>  if op(0) = '0' then st <= exe2c;
		               else st <= exe1c;
					   end if;
		when exe2c => if no_fine = '1' then st <=  exe2c;
		               else st <= idle;
					   end if; 
		when others => st <= idle;
	end case;
end if;
end process;   



 enop <= '1' when st = letop  else '0';
 end0 <= '1' when st = decodifica  else '0';
 end1 <= '1'  when st = letd1 else '0';
 enexe1c <= '1' when st = exe1c  else '0';
 enexe2c <= '1' when st = exe2c  else '0';
 
	 
 no_fine <= enexe2c and not conta;

process(clk)  
variable num: integer range 0 to 16;
begin
	if clk'event and clk='0' then
		if enop ='1' then op<= din(1 downto 0);
			conta<='0';
	    end if;
		
		if end0 = '1' then d0 <= din;
		end if;
		if end1 = '1' then d1 <= din;
		end if;
		if enexe1c='1' then 
			if op = "01" then 	--or
					ris <= d0 or d1;
				else 		 	  -- cnt1
					num:=0;
		   			for i in 0 to 15 loop
						if d0(i) = '1' then num := num+1;
						end if;
					end loop;
					ris <= conv_std_logic_vector(num,16);
			end if;	
		end if;
		
		
		if enexe2c='1' then  
			
			if no_fine= '1' then
				conta <= '1';
			else if op = "00" then		--shl
					 ris <= shl(d0,d1);
	 			 else					--par
			  		num:=0;
			  		for i in 0 to 15 loop
						if d0(i) = '1' then num := num+1;
						end if;
			  		end loop;
			  		ris <= conv_std_logic_vector(num mod 2, 16);
			
				end if;	
		  	end if;	
	    end if;
		  
		fine <= enexe1c or (enexe2c and not no_fine);  
     end if;
	end process;
end beh;
	


